#include 'minigui.ch'


PROCEDURE ExpMst
   private lAddmode := .f.

   if isWindowDefined(frmExp)
      return nil
   endif

   netselect("Exp")
   set order to tag Expnm
   go top


   DEFINE WINDOW frmExp            ;
      AT 0,0               ;
      WIDTH 635            ;
      HEIGHT 460            ;
      TITLE 'Expense Head Setup'   ;
      CHILD ;
      FONT 'ARIAL' SIZE 9         ;
      ON INIT   (DeactivateEdit(), RefreshData() )

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 50,30 FLAT RIGHTTEXT BORDER

      BUTTON btnFirst       ;
         CAPTION '&Top' ;
         picture "HP_TOP" ;
         ACTION ( Exp->(dBGoTop()) , frmExp.Browse_1.Value := Exp->(RecNo()) )

      BUTTON btnPrev    ;
         CAPTION '&Prev'    ;
         PICTURE "HP_BACK" ;
         ACTION ( Exp->(dBSkip ( -1 )) , frmExp.Browse_1.Value := Exp->(RecNo()) )

      BUTTON btnNext   ;
         CAPTION '&Next'    ;
         PICTURE "HP_NEXT" ;
         ACTION ( Exp->(dBSkip (1)) , if ( Exp->(Eof()) , Exp->(DbGoBottom()) , Nil ) , ;
         frmExp.Browse_1.Value := Exp->(RecNo()) )

      BUTTON btnLast       ;
         CAPTION '&Last'    ;
         PICTURE "HP_END" ;
         ACTION ( Exp->(dBGoBottom ()) , frmExp.Browse_1.Value := Exp->(RecNo()) )  SEPARATOR

      BUTTON btnAdd       ;
         CAPTION '&Add'    ;
         PICTURE "MINIGUI_EDIT_ADD" ;
         ACTION (lAddMode := .T., AddRec())

      BUTTON btnModify       ;
         CAPTION '&Modify'    ;
         PICTURE "MINIGUI_EDIT_EDIT" ;
         ACTION If ( CheckRLock() , ActivateEdit() , Nil )

      BUTTON btnDelete    ;
         CAPTION '&Delete'   ;
         PICTURE "MINIGUI_EDIT_DELETE" ;
         ACTION DeleteRec()
         

      END TOOLBAR

      @ 56, 10 TEXTBOX txtSearch ;
         width 190 ;
         height 24 ;
         on change {|| Exp->(dbseek(upper(this.value), .t.)), ;
         	frmExp.browse_1.value := Exp->(recno())}

      @ 86,10 BROWSE Browse_1            ;
         WIDTH 190              ;
         HEIGHT 330             ;
         HEADERS { 'Expense Heads' }   ;
         WIDTHS { 180 }         ;
         WORKAREA Exp        ;
         FIELDS { 'Exp->Expnm' } ;
         ON CHANGE RefreshData() ;
         ON DBLCLICK ( ActivateEdit() , If ( ! CheckRLock() , DeactivateEdit() , Nil ) )


      @ 56,210 FRAME FRAME_1 ;
         WIDTH 400      ;
         HEIGHT 360


      @ 66 , 220 LABEL LABEL_1 ;
         VALUE 'Exp. Head:' ;
         WIDTH 80

      @ 66 , 290 TEXTBOX txtExpnm ;
         width 200 ;
         MAXLENGTH 40

      @ 96 , 220 LABEL LABEL_2 ;
         VALUE 'Value:' ;
         WIDTH 80
         
      @ 96 , 290 TEXTBOX txtAmt ;
         NUMERIC INPUTMASK "999,999,999.99"
         
      @ 126 , 220 LABEL LABEL_3 ;
         VALUE 'Remarks:' ;
         WIDTH 80
         
      @ 126 , 290 TEXTBOX txtRem ;
         width 200 ;
         MAXLENGTH 80 



      @ 376,320 BUTTON cmdSave ;
         CAPTION '&Save' ;
         PICTURE "MINIGUI_EDIT_OK" LEFT ;
         ACTION SaveRec()

      @ 376,425 BUTTON cmdCancel ;
         CAPTION '&Cancel' ;
         PICTURE "MINIGUI_EDIT_CANCEL"  LEFT ;
         ACTION CancelRec()

   END WINDOW

   frmExp.Browse_1.SetFocus
   CENTER WINDOW frmExp
   ACTIVATE WINDOW frmExp

   RETURN




static PROCEDURE DeactivateEdit
   frmExp.Browse_1.Enabled  := .T.
   frmExp.txtSearch.Enabled := .t.
   frmExp.txtExpnm.enabled := .f.
   frmExp.txtAmt.enabled := .f.
   frmExp.txtRem.enabled := .f.
   

   frmExp.cmdSave.Enabled      := .F.
   frmExp.cmdCancel.Enabled      := .F.
   frmExp.ToolBar_1.Enabled      := .T.
   frmExp.Browse_1.SetFocus
   RETURN


static PROCEDURE ActivateEdit
   frmExp.Browse_1.Enabled  := .f.
   frmExp.txtSearch.Enabled := .f.
   frmExp.txtExpnm.enabled := .t.
   frmExp.txtAmt.enabled := .t.
   frmExp.txtRem.enabled := .t.

   frmExp.cmdSave.Enabled      := .t.
   frmExp.cmdCancel.Enabled      := .t.
   frmExp.ToolBar_1.Enabled      := .f.
   frmExp.txtExpnm.SetFocus
   RETURN


static PROCEDURE CancelRec()
   DeactivateEdit()
   RefreshData()
   UNLOCK
   lAddmode := .f.
   RETURN


static PROCEDURE SaveRec()
   local mOldrec

   if empty(frmExp.txtExpnm.value)
      msgbox("Expense Head Name cannot be blank!", thiswindow.title); frmExp.txtExpnm.setfocus(); return
   endif

   netselect("Exp")
   mOldrec = iif(eof(), 0, recno())

   locate for upper(Expnm) = upper(frmExp.txtExpnm.value) .and. (lAddmode .or. recno() <> mOldrec)
   if found()
      if mOldrec <> 0
         go mOldrec
      endif
      msgbox("Duplicate Expense Head Name!", thiswindow.title); frmExp.txtExpnm.setfocus(); return
   endif

   if mOldrec <> 0 .and. !lAddMode
      go mOldrec
   endif

   If lAddmode == .T.
      Exp->(DbAppend())
      Exp->Expid := newid("Exp")
      lAddmode := .F.
   else
      rlock()
   EndIf

   Exp->Expnm := frmExp.txtExpnm.value
   Exp->Amt := frmExp.txtAmt.value
   Exp->Rem := frmExp.txtRem.value
   frmExp.Browse_1.Refresh
   frmExp.Browse_1.Value := Exp->(RecNo())

   COMMIT
   UNLOCK
   DeactivateEdit()

   RETURN



static PROCEDURE AddRec()
   frmExp.txtExpnm.value := ''
   frmExp.txtAmt.value := 0.00
   frmExp.txtRem.value := ''
   ActivateEdit()
   RETURN


static PROCEDURE RefreshData()
   frmExp.txtExpnm.value := Exp->Expnm
   frmExp.txtAmt.value := Exp->Amt
   frmExp.txtRem.value := Exp->Rem
Return



static Procedure DeleteRec
	local mRefrec

	netselect("tran")
	mRefrec := iif(eof(), 0, recno())
	locate for expid == exp->expid
	if found()
		if mRefrec <> 0
			go (mRefrec)
		endif
		netselect("Exp")
		msgbox("Cannot delete. Transaction exits!", thiswindow.title)
		return nil
	endif
	if mRefrec <> 0
		go (mRefrec)
	endif
	netselect("Exp")

   If MsgYesNo ( 'Are you sure?',thiswindow.title)

      If CheckRLock()
         Exp->(dbdelete())
         commit
         if !Exp->(eof())
            Exp->(dbskip())
         endif
         if !Exp->(eof())
            Exp->(dbgobottom())
         endif
         frmExp.Browse_1.Refresh
         frmExp.Browse_1.Value := Exp->(RecNo())
         RefreshData()
      EndIf
   EndIf
   Return