#include "dbstruct.ch"
#include "minigui.ch"


Procedure Main
   private  WinMain

   Set_prog()

   DEFINE WINDOW WinMain ;
      AT 0,0 ;
      WIDTH 640 ;
      HEIGHT 460 ;
      TITLE "My Expense" ;
      ICON "LogoIcon" ;
      MAIN   ;
      backcolor {0, 128, 192};
      on init Start_prog()

      @ 23, 27 LABEL lbl_1 VALUE "My Expense: An Expense Management Software for You" AUTOSIZE ;
         FONT "Verdana" SIZE 18 BOLD ITALIC ;
         FONTCOLOR BLACK TRANSPARENT
      @ 20, 24 LABEL lbl_2 VALUE "My Expense: An Expense Management Software for You" AUTOSIZE ;
         FONT "Verdana" SIZE 18 BOLD ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT

      @ 100, 24 LABEL lbl_5 ;
         VALUE "Developed by: Sudip Bhatttacharyya" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 120, 24 LABEL lbl_6 ;
         VALUE "Email:" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 120, 65 hyperlink email ;
         value "sudipb001@gmail.com" ;
         width 200 ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT HANDCURSOR ;
         address "sudipb001@gmail.com"
         
      @ 150, 24 LABEL lbl_7 ;
         VALUE "Created with HMG, by Roberto Lopez" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 170, 24 LABEL lbl_8 ;
         VALUE "Created with help from S. Rathinagiri, Bicahi Esgici, Javier Parada" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
         
      @ 200, 24 LABEL lbl_9 ;
         VALUE "Ver 0.6a" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT

         
      DEFINE MAIN MENU
         DEFINE POPUP "&File"
            MENUITEM "E&xit"           action Exit_Prog()
         END POPUP
         define popup "&Entry"
            menuitem "&Expense Head Setup" action ExpMst()
            menuitem "&Daily Expense Entry" action TranEntry()
         end popup
         define popup "&Report"
         	menuitem "&Expense Report" action TranPrint()
         end popup
         define popup "&Tools"
         	menuitem "Repair &Data" action RepairData()
         end popup
      END MENU


   END WINDOW
   // center window winMain
   Maximize window winMain
   ACTIVATE WINDOW WinMain
return


Function Set_prog()
   set talk off
   set dele on
   set date brit
   set cent on
   set epoch to 1950
   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED
   REQUEST DBFCDX , DBFFPT
   RDDSETDEFAULT( "DBFCDX" )
return nil



Function Setup_tables()
   s_ids()
   s_exp()
   s_tran()
return nil


Function Start_prog()
   Setup_Tables()
return nil

Function Exit_prog()
   release window winmain
   close all
return nil




   //----------------------------------------- ids.dbf
function s_ids()
   local adbf := {}
   aadd(adbf,	{"table",		"c",	20,		0})
   aadd(adbf,	{"nextid",		"c",	10,		0})
   if dbcreachk("ids", adbf) .or. !file("ids.cdx")
      if select("ids") = 0
         use ids exclusive
      endif
      select ids
      index on table tag table
   endif
return nil



   //----------------------------------------- exp.dbf
function s_exp()
   local adbf := {}
   aadd(adbf,	{"expid",		"c",	10,		0})
   aadd(adbf,	{"expnm",		"c",	40,		0})
   aadd(adbf,	{"amt",			"n",	12,		2})
   aadd(adbf,	{"rem",			"c",	80,		0})
   if dbcreachk("exp", adbf) .or. !file("exp.cdx")
      if select("exp") = 0
         use exp exclusive
      endif
      select exp
      index on expid tag expid
      index on upper(expnm) tag expnm
   endif
return nil



   //----------------------------------------- tran.dbf
function s_tran()
   local adbf := {}
   aadd(adbf,	{"tranid",		"c",	10,		0})
   aadd(adbf,	{"trandt",		"d",	 8,		0})
   aadd(adbf,	{"expid",		"c",	10,		0})
   aadd(adbf,	{"amt",			"n",	12,		2})
   aadd(adbf,	{"pmtby",		"c",	10,		0})
   aadd(adbf,	{"chqno",		"c",	10,		0})
   aadd(adbf,	{"chqdt",		"d",	 8,		0})
   aadd(adbf,	{"cardno",		"c",	20,		0})
   aadd(adbf,	{"banknm",		"c",	40,		0})
   aadd(adbf,	{"rem",			"c",	80,		0})
   if dbcreachk("tran", adbf) .or. !file("tran.cdx")
      if select("tran") = 0
         use tran exclusive
      endif
      select tran
      index on tranid tag tranid
      index on trandt tag trandt
      index on expid tag expid
      index on pmtby tag pmtby
   endif
return nil




FUNCTION dbCreaChk(fname, adbf)
   local aStruct, option, lChange := .f., lNew := .f., i, newrec, oldrec
   fname := upper(fname)
   if !file(fname+".dbf")
      set exclusive on
      dbcreate(fname, adbf)
      set exclusive off
      return .t.
   endif
   use (fname)
   aStruct = dbstruct()
   use

   if len(aStruct) != len(adbf)
      lChange = .t.
   else
      i = 1
      do while i <= len(aStruct) .and. !lNew .and. !lChange
         if len(aStruct[i, DBS_NAME]) != len(adbf[i, DBS_NAME]) ;
            .or. upper(aStruct[i, DBS_NAME]) != upper(adbf[i, DBS_NAME]) ;
            .or. upper(aStruct[i, DBS_TYPE]) != upper(adbf[i, DBS_TYPE]) ;
            .or. aStruct[i, DBS_LEN] != adbf[i, DBS_LEN] ;
            .or. aStruct[i, DBS_DEC] != adbf[i, DBS_DEC]
            lChange = .t.
         endif
         i++
      enddo
   endif

   if lChange
      if msgyesno(fname+" structure has been changed. Change";
         +" the structure ?")
         set exclusive on
         use (fname)
         pack
         oldrec = reccount()
         use
         deletefile("settemp.dbf")
         if renamefile(fname+".dbf", "settemp.dbf") != 0
            msginfo("Cannot change file structure!",)
            QUIT
         ENDIF
         dbcreate(fname, adbf)
         use (fname)
         append from settemp
         newrec = reccount()
         use
         if newrec != oldrec
            msginfo("Problem in creating file :"+fname+;
               ". You can get all records in the file SETTEMP.DBF")
            quit
         endif
         deletefile("settemp.dbf")
         set exclusive off
         return .t.
      else
         msginfo(fname+" structure mismatch")
         quit
      endif
   endif
return .f.



function NetSelect(cTable)
   if select(cTable) = 0
      use &cTable shared new
   endif
   select &cTable
   return nil

   
Function CheckRLock()
   Local RetVal

   If RLock()
      RetVal := .t.
   Else
      MsgExclamation ('Another user already locked this record')
      RetVal := .f.
   EndIf
   Return RetVal


/****
*
****/
Function SaveDbf( )

Return( { Select(), Iif( Used(), OrdSetFocus(), .F.) , Iif( Used(), Recno(), .F. ) } )
/********/

/****
*
****/
Procedure RestDbf( _Arreglo )

  Select( _Arreglo[1] )
  If ValType( _Arreglo[2] ) = "C" .and. ! Empty( _Arreglo[2] )
     OrdSetFocus( _Arreglo[2] )
  Endif
  If ValType( _Arreglo[3] ) = 'N'
     Go _Arreglo[3]
  Endif

Return
/********/      