#include 'minigui.ch'


PROCEDURE TranEntry
   private lAddmode := .f., aExpid := {}, aExpnm := {}, aAmt := {}, ;
   	aPmtBy := {'UNPAID', 'CASH', 'CHEQUE/DD', 'CARD', 'OTHERS'}, aWAExp := {}, aWATran := {}

   if isWindowDefined(frmTran)
      return nil
   endif
   
   netselect("Exp")
   set order to tag Expnm
   go top
   dbeval({|| aadd(aExpid, Exp->Expid), aadd(aExpnm, Exp->Expnm), aadd(aAmt, exp->amt)})
   set order to tag Expid
   
   netselect("Tran")
   set relation to Expid into Exp
   set order to tag Trandt
   set softseek on
   seek date()
   if eof()
   	go bottom
   endif

   DEFINE WINDOW frmTran            ;
      AT 0,0               ;
      WIDTH 735            ;
      HEIGHT 560            ;
      TITLE 'Daily Expense'   ;
      CHILD ;
      FONT 'ARIAL' SIZE 9         ;
      ON INIT   (DeactivateEdit(), RefreshData() ) ;
      ON RELEASE (Netselect("tran"), dbsetrelation("Exp", NIL)) ;
      ON GOTFOCUS WinGotFocus() ;
      ON LOSTFOCUS WinLostFocus()

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 50,30 FLAT RIGHTTEXT BORDER

      BUTTON btnFirst       ;
         CAPTION '&Top' ;
         picture "HP_TOP" ;
         ACTION ( Tran->(dBGoTop()) , frmTran.Browse_1.Value := Tran->(RecNo()) )

      BUTTON btnPrev    ;
         CAPTION '&Prev'    ;
         PICTURE "HP_BACK" ;
         ACTION ( Tran->(dBSkip ( -1 )) , frmTran.Browse_1.Value := Tran->(RecNo()) )

      BUTTON btnNext   ;
         CAPTION '&Next'    ;
         PICTURE "HP_NEXT" ;
         ACTION ( Tran->(dBSkip (1)) , if ( Tran->(Eof()) , Tran->(DbGoBottom()) , Nil ) , ;
         frmTran.Browse_1.Value := Tran->(RecNo()) )

      BUTTON btnLast       ;
         CAPTION '&Last'    ;
         PICTURE "HP_END" ;
         ACTION ( Tran->(dBGoBottom ()) , frmTran.Browse_1.Value := Tran->(RecNo()) )  SEPARATOR

      BUTTON btnAdd       ;
         CAPTION '&Add'    ;
         PICTURE "MINIGUI_EDIT_ADD" ;
         ACTION (lAddMode := .T., AddRec())

      BUTTON btnModify       ;
         CAPTION '&Modify'    ;
         PICTURE "MINIGUI_EDIT_EDIT" ;
         ACTION If ( CheckRLock() , ActivateEdit() , Nil )

      BUTTON btnDelete    ;
         CAPTION '&Delete'   ;
         PICTURE "MINIGUI_EDIT_DELETE" ;
         ACTION DeleteRec()
         
     BUTTON btnPrint    ;
         CAPTION '&Print'   ;
         PICTURE "MINIGUI_EDIT_PRINT" ;
         ACTION TranPrint()

         
      END TOOLBAR
      
      @ 56, 10 label lblSearch ;
      	value "Search:"

      @ 56, 60 DATEPICKER dpkSearch ;
         height 24 ;
         on change {|| Tran->(dbseek(this.value, .t.)), ;
         	frmTran.browse_1.value := Tran->(recno())}

      @ 86,10 BROWSE Browse_1            ;
         WIDTH 290              ;
         HEIGHT 430             ;
         HEADERS { 'Date', 'Head', 'Amount' }   ;
         WIDTHS { 75, 100, 75 }         ;
         WORKAREA Tran        ;
         FIELDS { 'Tran->Trandt', 'Exp->Expnm', 'Tran->Amt' } ;
         ON CHANGE RefreshData() ;
         ON DBLCLICK ( ActivateEdit() , If ( ! CheckRLock() , DeactivateEdit() , Nil ) )


      @ 56,310 FRAME FRAME_1 ;
         WIDTH 400      ;
         HEIGHT 460


      @ 66 , 320 LABEL lblTrandt ;
         VALUE 'Date:' ;
         WIDTH 80
      @ 66 , 390 DATEPICKER dpkTrandt
      
      @ 96, 320 LABEL lblExpid ;
      	 VALUE "Head:"
      	 width 80
      @	96, 390 COMBOBOX cboExpid ;
      	width 300 ;
      	items aExpnm ;
      	on change SetAmt()
      	
      @ 126, 320 LABEL lblAmt;
      	VALUE "Amount:"
      @ 126, 390 TEXTBOX txtAmt ;
          NUMERIC INPUTMASK "999,999,999.99" 
          
	  @ 156, 320 label lblPmtby ;
	  	value "Pmt By:"
	  @ 156, 390 combobox cboPmtBy ;
	  	width 100 ;
	  	items aPmtBy
	  	
	  @ 186, 320 label lblChqno ;
	  	value "Chq/DD No.:"
	  @ 186, 390 textbox txtChqno ;
	  	maxlength 10
	  	
	  @ 216, 320 label lblChqdt ;
	  	value "Chq/DD Dt.:"
	  @ 216, 390 datepicker dpkChqdt shownone
	  
	  @ 246, 320 label lblBanknm ;
	  	value "Bank:" 
	  @ 246, 390 text txtBanknm ;
	  	width 300 ;
	  	maxlength 40
	  
	  @ 276, 320 label lblCardno ;
	  	value "Card No.:"
	  @ 276, 390 text txtCardno ;
	  	width 200 ;
	  	maxlength 20
	  	
	  @ 306, 320 label lblRem ;
	  	value "Remarks:"
	  @ 306, 390 editbox edtRem ;
	  	width 200 ;
	  	height 90 ;
	  	maxlength 80

      @ 476,420 BUTTON cmdSave ;
         CAPTION '&Save' ;
         PICTURE "MINIGUI_EDIT_OK" LEFT ;
         ACTION SaveRec()

      @ 476,525 BUTTON cmdCancel ;
         CAPTION '&Cancel' ;
         PICTURE "MINIGUI_EDIT_CANCEL"  LEFT ;
         ACTION CancelRec()

   END WINDOW

   frmTran.Browse_1.SetFocus
   CENTER WINDOW frmTran
   ACTIVATE WINDOW frmTran

   RETURN


   
static function SetAmt()
	local temp := 0.00
	if frmTran.cboExpid.value = 0
		return nil
	endif
	temp := aAmt[frmTran.cboExpid.value]
	if temp <> 0.00
		frmTran.txtAmt.value := temp
	endif
	return nil
	   


static PROCEDURE DeactivateEdit
   frmTran.Browse_1.Enabled  := .T.
   frmTran.dpkSearch.Enabled := .t.
   frmTran.dpkTrandt.enabled := .f.
   frmTran.cboExpid.enabled := .f.
   frmTran.txtAmt.enabled := .f.
   frmTran.cboPmtby.enabled := .f.
   frmTran.txtChqno.enabled := .f.
   frmTran.dpkChqdt.enabled := .f.
   frmTran.txtBanknm.enabled := .f.
   frmTran.txtCardno.enabled := .f.
   frmTran.edtRem.enabled := .f.
   
   frmTran.cmdSave.Enabled      := .F.
   frmTran.cmdCancel.Enabled      := .F.
   frmTran.ToolBar_1.Enabled      := .T.
   frmTran.Browse_1.SetFocus
   RETURN


static PROCEDURE ActivateEdit
   frmTran.Browse_1.Enabled  := .f.
   frmTran.dpkSearch.Enabled := .f.
   frmTran.dpkTrandt.enabled := .t.
   frmTran.cboExpid.enabled := .t.
   frmTran.txtAmt.enabled := .t.
   frmTran.cboPmtby.enabled := .t.
   frmTran.txtChqno.enabled := .t.
   frmTran.dpkChqdt.enabled := .t.
   frmTran.txtBanknm.enabled := .t.
   frmTran.txtCardno.enabled := .t.
   frmTran.edtRem.enabled := .t.

   frmTran.cmdSave.Enabled      := .t.
   frmTran.cmdCancel.Enabled      := .t.
   frmTran.ToolBar_1.Enabled      := .f.
   frmTran.dpkTrandt.SetFocus
   RETURN


static PROCEDURE CancelRec()
   DeactivateEdit()
   RefreshData()
   UNLOCK
   lAddmode := .f.
   RETURN


static PROCEDURE SaveRec()
   local mOldrec

   if empty(frmTran.dpkTrandt.value)
      msgbox("Date cannot be blank!", thiswindow.title); frmTran.dpkTrandt.setfocus(); return
   endif
   
   if empty(frmTran.cboExpid.value)
      msgbox("Please specify expense head", thiswindow.title); frmTran.cboExpid.setfocus(); return
   endif
   
   if empty(frmTran.cboPmtby.value)
      msgbox("Please specify payment by", thiswindow.title); frmTran.cboPmtby.setfocus(); return
   endif
   
   netselect("Tran")
   mOldrec = iif(eof(), 0, recno())

   if mOldrec <> 0 .and. !lAddMode
      go mOldrec
   endif

   If lAddmode == .T.
      Tran->(DbAppend())
      Tran->Tranid := newid("TRAN")
      lAddmode := .F.
   else
      rlock()
   EndIf

   Tran->Trandt := frmTran.dpkTrandt.value
   Tran->Expid := aExpid[frmTran.cboExpid.value]
   Tran->Amt := frmTran.txtAmt.value
   Tran->Pmtby := aPmtby[frmTran.cboPmtby.value]
   Tran->Chqno := frmTran.txtChqno.value
   Tran->Chqdt := frmTran.dpkChqdt.value
   Tran->Banknm := frmTran.txtBanknm.value
   Tran->Cardno := frmTran.txtCardno.value
   Tran->Rem := frmTran.edtRem.value
   
   frmTran.Browse_1.Refresh
   frmTran.Browse_1.Value := Tran->(RecNo())

   COMMIT
   UNLOCK
   DeactivateEdit()

   RETURN



static PROCEDURE AddRec()
   frmTran.dpkTrandt.value := date()
   frmTran.cboExpid.value := 0
   frmTran.txtAmt.value := 0.00
   frmTran.cboPmtby.value := 1
   frmTran.txtChqno.value := ""
   frmTran.dpkChqdt.value := ctod("")
   frmTran.txtBanknm.value := ""
   frmTran.txtCardno.value := ""
   frmTran.edtRem.value := ""

   ActivateEdit()
   RETURN


static PROCEDURE RefreshData()
   frmTran.dpkTrandt.value := Tran->Trandt
   frmTran.cboExpid.value := ascan(aExpid, tran->expid)
   frmTran.txtAmt.value := tran->amt
   frmTran.cboPmtby.value := ascan(aPmtby, alltrim(tran->pmtby))
   frmTran.txtChqno.value := tran->chqno
   frmTran.dpkChqdt.value := tran->chqdt
   frmTran.txtBanknm.value := tran->banknm
   frmTran.txtCardno.value := tran->cardno
   frmTran.edtRem.value := tran->rem
	Return



static Procedure DeleteRec

   If MsgYesNo ( 'Are you sure?')

      If CheckRLock()
         Tran->(dbdelete())
         commit
         if !Tran->(eof())
            Tran->(dbskip())
         endif
         if !Tran->(eof())
            Tran->(dbgobottom())
         endif
         frmTran.Browse_1.Refresh
         frmTran.Browse_1.Value := Tran->(RecNo())
         RefreshData()
      EndIf
   EndIf
   Return
   
   
static Function WinLostFocus()
	aWAExp = SaveDbf()
	netselect("tran")
	set relation to
	aWATran = SaveDbf()
	return nil
	
static Function WinGotFocus()
	local temp := frmTran.cboExpid.value
	aExpnm := {}
	aExpid := {}
	aAmt := {}
   netselect("Exp")
   set order to tag Expnm
   go top
   dbeval({|| aadd(aExpid, Exp->Expid), aadd(aExpnm, Exp->Expnm), aadd(aAmt, exp->amt)})
   set order to tag Expid
   
   frmTran.cboExpid.deleteallitems()
   aeval(aExpnm, {|x| frmTran.cboExpid.additem(x)}) 
   
   frmTran.cboExpid.value := temp

	if !empty(aWaExp)
		netselect("exp")
		set 
		RestDbf(awaExp)
	endif
	if !empty(aWaTran)
		RestDbf(awaTran)
	endif
	
	select tran
	set relation to expid into exp
	if reccount() != 0 .and. !eof()
		goto (recno())
	endif
	return nil