#include <minigui.ch>
#include <hfcl.ch>

Function TranPrint()
	PRIVATE mTranRec := 0, aRows := {}, aSum, aExpid := {}, aExpnm := {}, mOldRel
	
	aSum := {{.f.,""},{.f.,""},{.t.,"999,999,999.99"}, {.f.,""}, {.f.,""}}

	netselect("Exp")
   set order to tag Expnm
   go top
   dbeval({|| aadd(aExpid, Exp->Expid), aadd(aExpnm, Exp->Expnm)})
   set order to tag Expid	
   
   netselect("tran")
   set order to tag Expdt
   mOldRel := dbrelation()
   set relation to expid into exp
   

   DEFINE WINDOW frmTranPrint            ;
      AT 0,0               ;
      WIDTH 790            ;
      HEIGHT 590            ;
      TITLE 'Expense Report'   ;
      MODAL ;
      ON INIT {|| netselect("Tran"), mTranRec := iif(tran->(Eof()), 0, tran->(recno()))}  ;
      ON RELEASE {|| netselect("Tran"), iif(empty(mOldRel),dbsetrelation("Exp", NIL), NIL), ;
      	IIF(mTranRec <> 0, tran->(DBgoto(mTranrec)), NIL)}
      
      @ 10, 10 label lblFromdt value "From:"
      @ 10, 50 datepicker dpkFromdt value bom(date())
      
      @ 10, 200 label lblTodt value "To:"
      @ 10, 230 datepicker dpkTodt value eom(date())
     
      @ 10, 670 button cmdRun caption "&Run" ;
      	action CreateGrid()
      	
		@ 40, 10 label lblExpid value "Select head:" autosize
      @ 40, 80 COMBOBOX cboExpid ;
      	width 300 ;
      	items aExpnm ;
      	value 0 
		@ 40, 400 checkbox chkAllexp caption "All expense heads" ;
			width 200 value .t. ;
			on change {|| frmTranPrint.cboExpid.value := iif(this.value, 0, frmTranPrint.cboExpid.value), ;
				frmTranPrint.cboExpid.enabled := !frmTranPrint.chkAllExp.value} 
				
		@ 70,10 RADIOGROUP radRptType ;
			OPTIONS { 'All' , 'Paid Only' , 'Unpaid Only'} ;
			VALUE 1 ;
			WIDTH 75 ;
			HORIZONTAL
				
      
		@ 100,10 GRID Grid_1 ;
			WIDTH 650 ;
			HEIGHT 400 ;
			HEADERS {'Date','Head','Amount','Pmt by', 'Others'} ;
			WIDTHS {100,200,100,100,200} ;
			JUSTIFY {0,0,1,0,0};
			ITEMS aRows ;
			VALUE 1 
			
      @ 480, 670 button cmdPrint caption "&Print" ;
      	action DoPrint()
      
      @ 520, 450 label lblTotal value "Total:"
      @ 520, 500 textbox txtTotamt ;
      	readonly value 0.00 numeric inputmask "9999999.99"
      
   END WINDOW
   frmTranPrint.cboExpid.enabled := .f.
   frmTranPrint.center
   frmTranPrint.activate
	return NIL
	

static function CreateGrid()
	local mFromdt := frmTranPrint.dpkFromdt.value, mTodt := frmTranPrint.dpkTodt.value, ;
		mTotamt := 0.00, mExpid := '', mRptType := frmTranPrint.radRptType.value
	
	if frmTranPrint.cboExpid.value != 0
		mExpid := aExpid[frmTranPrint.cboExpid.value]
	endif
	
	frmTranPrint.grid_1.deleteallitems()
	aRows := {}
	netselect("tran")
	dbeval({|| aadd(aRows, {dtoc(tran->trandt), exp->expnm, str(tran->amt, 12, 2), tran->pmtby, tran->(getothers())}), mTotamt += tran->amt}, ;
		{|| (tran->trandt >= mFromdt .and. tran->trandt <= mTodt) .and. ;
		(empty(mExpid) .or. tran->expid = mExpid) .and. ;
		(mRptType = 1 .or. (mRptType = 2 .and. ALLTRIM(tran->pmtby) != "UNPAID") .or. ;
			(mRptType = 3 .and. ALLTRIM(tran->pmtby) == "UNPAID")) })
	aEval(aRows, {|x| frmTranPrint.grid_1.additem(x)})
	frmTranPrint.txtTotamt.value := mTotamt
	return nil
	
	
static function GetOthers()
	local mesg := ""
	if !empty(chqno)
		mesg += iif(empty(mesg), "", ", ")+"Chq/DD No.: "+alltrim(chqno)
	endif	
	if !empty(chqdt)
		mesg += iif(empty(mesg), "", ", ")+"Chq/DD Dt.: "+dtoc(chqdt)
	endif	
	if !empty(banknm)
		mesg += iif(empty(mesg), "", ", ")+"Bank: "+alltrim(banknm)
	endif	
	if !empty(cardno)
		mesg += iif(empty(mesg), "", ", ")+"Card No.: "+alltrim(cardno)
	endif
	return mesg
	
	
	
static function DoPrint()
	local mFromdt := frmTranPrint.dpkFromdt.value, mTodt := frmTranPrint.dpkTodt.value, ;
		strHead2, strHead3
	
	strHead2 := "("+dtoc(mFromdt)+" to "+dtoc(mTodt)+")"
	strHead3 := ""
	do case
		case frmTranPrint.radRptType.value = 2
			strHead3 := " for Paid Expenses"
		case frmTranPrint.radRptType.value = 3
			strHead3 := " for Unpaid Expenses"
	endcase
	PRINT GRID grid_1 OF frmTranPrint FONT "Arial" SIZE 12 ORIENTATION "P" ;
		HEADERS {"Expense Report"+strHead3, strHead2} COLUMNSUM aSum SHOWWINDOW

	return nil	